// MyDlg.cpp : implementation file
//
#pragma warning(disable : 4996)
#pragma warning(disable : 4244)
#include "stdafx.h"
#include "MyGraph.h"
#include "My.h"
#include "MyDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMyDlg dialog




CMyDlg::CMyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMyDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_GRA, m_gra);
  DDX_Control(pDX, IDC_GRA2, m_grb);
  DDX_Control(pDX, IDC_GRA3, m_grc);
  DDX_Control(pDX, IDC_GR6, m_gre);
}

BEGIN_MESSAGE_MAP(CMyDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_STN_CLICKED(IDC_GRA2, &CMyDlg::OnStnClickedGra2)
END_MESSAGE_MAP()


// CMyDlg message handlers

BOOL CMyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMyDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMyDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

    const int N = 1000; //see
    double* X1 = new double[N]; 
    double* Y1 = new double[N];
    double* X2 = new double[N]; 
    double* Y2 = new double[N];
    int n; double x, y; RECT rect;
// graph1:
    CDC* pCDCa = m_gra.GetDC();
    m_gra.GetClientRect(&rect);
    double xa1 = 0;
    double xb1 = 3.1415926 * 6;
    for(n=0; n<N; n++){
      X1[n] = x = xa1 + n*(xb1-xa1)/double(N);
      Y1[n] = sin(x);
      X2[n] = x = xb1/6.0 + n*(xb1-xa1)/double(2*N);
      Y2[n] = 0.8*cos(x);
    }
    CMyGraph *gra = new CMyGraph(pCDCa, rect);
    gra->Prepare(X1, Y1, 0, N);
    gra->Line(X1, Y1, 0, N);
    gra->Line(X2, Y2, 0, N);
    delete gra;
    ReleaseDC(pCDCa);
 // graph2:
    CDC* pCDCb = m_grb.GetDC();
    m_grb.GetClientRect(&rect);
    double ta = 0;
    double tb = 4*atan(1.0) * 20;
    double xa2 = -1, xb2 = 1, ya2 = -1, yb2 = 1; 
    double t;
    for(n=0; n<N; n++){
      t = ta + n*(tb-ta)/double(N);
      X1[n] = 0.5*(xa2+xb2) + 0.5*(xb2-xa2)*cos(t)*exp(-double(n)/double(N));
      Y1[n] = 0.5*(ya2+yb2) + 0.5*(yb2-ya2)*sin(t)*exp(-double(n)/double(N));
    }
    CMyGraph *grb = new CMyGraph(pCDCb, rect);
    grb->Prepare(X1, Y1, 0, N);
    grb->Line(X1, Y1, 0, N);
    delete grb;
    ReleaseDC(pCDCb);
// graph3: see, what is grc?
    CDC* pCDCc = m_grc.GetDC();
    m_grc.GetClientRect(&rect);
    double vx = 0.0;
    double vy = 0.0;
    x = y = 0;
    const int s1 = 1; 
    const int s2 = 2*s1 + 1;
    for(int n=0; n<N; n++){
      vx += rand()%s2-s1;
      vy += rand()%s2-s1;
      x += vx;
      y += vy;
      X1[n] = vx;
      Y1[n] = vy;
    }
    CMyGraph grc(pCDCc, rect);
    grc.Prepare(X1, Y1, 0, N);
    grc.Line(X1, Y1, 0, N);
    ReleaseDC(pCDCc);
// graph4: another view only
    CDC* pCDCe = m_gre.GetDC();
    m_gre.GetClientRect(&rect);
    CMyGraph gre(pCDCe, rect);
    gre.Prepare(X1, Y1, 0, N);
    gre.Line(X1, Y1, 0, N);
    ReleaseDC(pCDCe);
    delete[] X1;
    delete[] Y1;
    delete[] X2;
    delete[] Y2;
  }
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMyDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMyDlg::OnStnClickedGra2()
{
  // TODO: Add your control notification handler code here
}
